theory Adequacy
imports Lambda HOAS Translation CanonicalEq 
begin




text {* enc translate to canonical and well-formed terms *}

lemma enc_of_can: "X \<turnstile> t \<Longrightarrow> of_can sig_lam (trans_ctx X) (enc t) (exp_ty)"
  apply(simp add:exp_ty_def)
  apply(nominal_induct t avoiding: X rule:lam.strong_induct)
  apply(erule Lambda.wf_inv, simp add:trans_ctx_def lam.inject exp_ty_def, rule of_INC, rule of_VAR,simp)
  apply(erule Lambda.wf_inv, simp add:lam.inject app_exp_def)
  apply(rule of_INC, rule_tac  of_APP, rule_tac of_APP, rule of_CST)
  apply(rule sig_lam_elem)
  apply(simp_all add: exp_ty_def)
  apply(erule_tac x=var in Lambda.wf.strong_cases,simp_all)
  apply(simp add:abs_fresh lam.inject alpha lam_exp_def)
  apply(rule of_INC, rule_tac of_APP,  rule of_CST)
  apply(rule sig_lam_elem)
  apply(rule of_LAM)
  apply(rule trans_ctx_fresh,simp )
  apply(subgoal_tac "of_can sig_lam (trans_ctx (var#Xa)) (enc t1) (BASE cEXP)")
  apply(simp add:trans_ctx_def exp_ty_def)
  apply(simp)
  done




text {* enc_range coincides with EXP. *}



lemma enc_range_imp_of_can_ : 
  "enc_range x \<Longrightarrow> fvs x \<subseteq> set X \<Longrightarrow> of_can sig_lam (trans_ctx (X)) x (BASE cEXP)"
  apply(nominal_induct x avoiding: X rule:enc_range.strong_induct)
  apply(simp_all)
  apply(rule of_INC, rule of_VAR)
  apply(simp add:trans_ctx_def)
  apply(clarsimp)
  apply(rule of_INC, rule of_APP, rule of_APP, rule of_CST)
  apply(rule sig_lam_elem)
  apply(simp_all)
  apply(rule of_INC, rule of_APP,rule of_CST)
  apply(rule sig_lam_elem)
  apply(rule of_LAM)
  apply(erule trans_ctx_fresh)
  apply(drule_tac x="x#X" in meta_spec )
  apply(subgoal_tac "fvs u \<subseteq> set (x # X)")
  apply(simp add:trans_ctx_def)
  apply(simp)
  apply(auto)
  done

lemma enc_range_imp_of_can : 
  "enc_range x \<Longrightarrow> fvs x = set X \<Longrightarrow> of_can sig_lam (trans_ctx X) x (BASE cEXP)"
  apply(drule_tac X="X" in enc_range_imp_of_can_)
  apply(simp)
  apply(clarsimp)
  done


  


lemma atm_not_three_argument : 
  "( of_atm sig_lam (trans_ctx X) x (ty1 ~> (ty2 ~> (ty3 ~> ty))) \<Longrightarrow> False)"
  apply(induct x arbitrary: X ty1 ty2 ty3 ty rule: hoas_height_induct)
  apply(clarsimp)
  apply(erule of_atm.cases)+
  apply(auto dest:ctx_lookup)
  apply(simp add:sig_lam_def hoas_ty.inject)
  done


lemma can_imp_enc_range : "of_can sig_lam (trans_ctx X) x (BASE cEXP) \<Longrightarrow> enc_range x"
  apply(induct x arbitrary: X  rule: hoas_height_induct)
  apply(clarify, simp add:hoas_ty.inject,clarify)
  apply(erule of_atm.cases)
    (* case 1: var, done. *)
  apply(clarsimp)
    (* case 2: application.  need to invert & use not-three_argument *)
  apply(clarsimp)
  apply(erule of_atm.cases,auto dest:ctx_lookup)
    (* case 2a: cAPP *)
  apply(erule of_atm.cases,auto dest:ctx_lookup)
  apply(drule atm_not_three_argument,simp)
  apply(simp add: sig_lam_def, auto simp add:hoas_ty.inject)
  apply(erule_tac x = t2a in  allE)
  apply(erule impE,simp)
  apply(erule mp)
  apply(rule_tac x="xa" in exI)
  apply(blast)

  apply(erule_tac x = "t2" in  allE)
  apply(erule impE,simp)
  apply(erule mp)
  apply(rule_tac x="xa" in exI)
  apply(blast)

(* case 2b:  *)
  apply(simp add:cEXP_def cPROP_def)
(* case 2c: cLAM *)
  apply(simp add: sig_lam_def, auto simp add:hoas_ty.inject)
  apply(erule of_can.cases,auto simp add:hoas_ty.inject)
  apply(erule_tac x="t1" in allE)
  apply(erule impE,simp)
  apply(erule mp)
  apply(rule_tac x="x#xa" in exI)
  apply(auto simp add:trans_ctx_def)

  apply(simp add: sig_lam_def)
  done






(* Validity, injectivity and surjectivity modulo definitional equivalence *)

lemma enc_wf: "\<lbrakk>X \<turnstile> t\<rbrakk> \<Longrightarrow> sig_lam, trans_ctx X \<turnstile> enc t : exp_ty"
  apply(blast intro: of_wf(2) enc_of_can)
  done


lemma wf_enc_valid:
  "sig_lam,trans_ctx X \<turnstile> enc t : BASE cEXP \<Longrightarrow> X \<turnstile> t"
  apply(nominal_induct t avoiding: X rule:lam.strong_inducts)
  apply(simp_all)
  (* case 1 *)
  apply(erule HOAS.wf_inv,simp_all add: hoas.inject)
  apply(clarify,erule trans_set_inv[simplified])
    (* case 2 *)
  apply(erule wf_inv, simp_all add:hoas.inject,clarify)+
  apply(drule sig_lam_lookup, simp add: hoas_ty.inject,clarify)
  apply(blast)
    (* case 3 *)
  apply(erule wf_inv, simp_all add:hoas.inject,clarify)
  apply(erule wf_inv, simp_all add:hoas.inject,clarify)
  apply(erule_tac x=var in wf.strong_cases, simp_all add:hoas.inject abs_fresh alpha trans_ctx_fresh,clarify)
  apply(drule sig_lam_lookup, simp add: hoas_ty.inject,clarify)
  apply(drule_tac x="var # X" in meta_spec, auto simp add:trans_ctx_simp)
  done


lemma wf_equiv_enc_equal_: 
  "\<lbrakk>sig_lam,trans_ctx X \<turnstile> enc t \<approx> enc u : BASE cEXP;valid X;X \<turnstile> t ; X \<turnstile> u\<rbrakk> \<Longrightarrow> t = u"
  apply(drule completeness, simp_all add:valid_trans_valid sig_lam_valid)
  apply(clarify)
  apply(subgoal_tac "sig_lam,trans_ctx X \<turnstile> enc t \<Up> enc t : BASE cEXP")
  prefer 2 apply(rule canonical_equals_can, rule enc_of_can[simplified],simp)
  apply(subgoal_tac "sig_lam,trans_ctx X \<turnstile> enc u \<Up> enc u : BASE cEXP")
  prefer 2 apply(rule canonical_equals_can, rule enc_of_can[simplified],simp)
  apply(subgoal_tac "enc t = enc u", insert  enc_inj,  simp add: inj_on_def)
  apply(subgoal_tac "N = enc t")
  prefer 2 apply(erule to_determinacy, simp_all add:valid_trans_valid sig_lam_valid)
  apply(erule to_determinacy, simp_all add:valid_trans_valid sig_lam_valid)
  done

lemma wf_equiv_enc_equal: 
  "\<lbrakk>sig_lam,trans_ctx X \<turnstile> enc t \<approx> enc u : BASE cEXP;valid X\<rbrakk> \<Longrightarrow> t = u"
  apply(frule wf_equiv_enc_equal_)
  apply(auto intro!: wf_enc_valid wf_equiv_wf intro:wf_equiv_sym simp add: valid_trans_valid)
  done
  
lemma wf_implies_enc_exists: 
  "\<lbrakk>sig_lam,trans_ctx X \<turnstile> M : BASE cEXP; valid X\<rbrakk> \<Longrightarrow> \<exists> t. sig_lam,trans_ctx X \<turnstile> M \<approx> enc(t) : BASE cEXP"
  apply(frule canonicalization)
  apply(simp_all add:valid_trans_valid sig_lam_valid)
  apply(clarify)
  apply(frule soundness)
  apply(drule can_imp_enc_range)
  apply(drule range_in_enc)
  apply(clarify)
  apply(rule_tac x="t" in exI)
  apply(erule equivalence,simp_all add:valid_trans_valid sig_lam_valid)
  done





text {* enc is a substitution-preserving morphism ("compositional bijection") *}


theorem enc_preserves_subst: "enc (t[x::=t']) = HOAS.subst (enc t) x (enc t')"
  apply(nominal_induct t avoiding: x t' rule: lam.strong_induct)
  by(auto simp add:enc_fresh)





(* Preservation for HOAS derivations *)
  

lemma RED_beta: 
  "\<lbrakk>sig_lam,(x,exp_ty)#\<Gamma> \<turnstile> m : exp_ty ;
  sig_lam,\<Gamma> \<turnstile> n : exp_ty;
  x \<sharp> (\<Gamma>,n)\<rbrakk> \<Longrightarrow> 
  sig_lam,\<Gamma>,thy_lam \<rightharpoonup> red_prop (app_exp (lam_exp (LAM x m)) n)
                                (m{x::=n})"
  apply(simp add: red_prop_def)
  apply(rule_tac \<phi>="RED_beta" in solve_ATOM)
  apply(simp add:thy_lam_def)
  apply(subgoal_tac "\<exists> y::var. var 0 = y")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> z::var. var 1 = z")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "RED_beta = \<Pi>[c:(BASE cEXP ~> BASE cEXP)].\<Pi>[ca:BASE cEXP].ATOM (APP (APP (CST cRED) (APP (APP (CST cAPP) (APP (CST cLAM) (VAR (c)))) (VAR (ca))))
                            (APP (VAR (c))
                              (VAR (ca))))")
  prefer 2 apply(simp add:RED_beta_def)
           apply(simp add: fresh_prod fresh_atm)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add: RED_beta_def)
    (* finally we can start instantiating *)
  apply(rule_tac t="LAM x m" in asolve_FORALL)
  apply(rule wf_LAM,simp add:fresh_prod,assumption)
    prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm)
  apply(rule_tac t="n" in asolve_FORALL,assumption)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm subst_fresh_id)
  apply(rule asolve_ATOM)
  apply(auto intro:wf_equiv.intros sig_lam_elem[simplified] intro: simp add:prop_ty_def )
  apply(erule wf_equiv_refl)+
  done


lemma RED_app1:
  "\<lbrakk>sig_lam,\<Gamma>,thy_lam \<rightharpoonup> red_prop m p; sig_lam,\<Gamma> \<turnstile> m : exp_ty;sig_lam,\<Gamma> \<turnstile> n : exp_ty;sig_lam,\<Gamma> \<turnstile> p : exp_ty\<rbrakk> \<Longrightarrow> 
  sig_lam,\<Gamma>,thy_lam \<rightharpoonup> red_prop (app_exp m n) (app_exp p n)"
  apply(simp add: red_prop_def)
  apply(rule_tac \<phi>="RED_app1" in solve_ATOM)
  apply(simp add:thy_lam_def)
  apply(simp add:RED_app1_def)
  apply(subgoal_tac "\<exists> M::var. var 0 = M")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> N::var. var 1 = N")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> P::var. var 2 = P")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "
    RED_app1
    = \<Pi>[c:BASE cEXP].
    \<Pi>[ca:BASE cEXP].
    \<Pi>[cb:BASE cEXP].(ATOM (APP (APP (CST cRED) (VAR (c))) (VAR (cb)))  
    \<rightarrow> ATOM (APP (APP (CST cRED) (APP (APP (CST cAPP) (VAR (c))) (VAR (ca)))) (APP (APP (CST cAPP) (VAR (cb)))
                                                             (VAR (ca)))))
")
  prefer 2 apply(simp add: fresh_prod fresh_atm RED_app1_def)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add:RED_app1_def)
  apply(rule_tac t="m" in asolve_FORALL,assumption)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm)
  apply(rule_tac t="n" in asolve_FORALL,assumption)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm subst_fresh_id)
  apply(rule_tac t="p" in asolve_FORALL,assumption)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm subst_fresh_id)
  apply(rule asolve_IMP)
  apply(simp)
  apply(rule asolve_ATOM)
  apply(rule wf_equiv_refl)  
  apply(auto intro:wf_equiv.intros sig_lam_elem[simplified] intro: simp add:prop_ty_def )
  done


lemma RED_app2:
  "\<lbrakk>sig_lam,\<Gamma>,thy_lam \<rightharpoonup> red_prop n p; sig_lam,\<Gamma> \<turnstile> m : exp_ty;sig_lam,\<Gamma> \<turnstile> n : exp_ty;sig_lam,\<Gamma> \<turnstile> p : exp_ty\<rbrakk> \<Longrightarrow> 
  sig_lam,\<Gamma>,thy_lam \<rightharpoonup> red_prop (app_exp m n) (app_exp m p)"
  apply(simp add: red_prop_def)
  apply(rule_tac \<phi>="RED_app2" in solve_ATOM)
  apply(simp add:thy_lam_def)
  apply(subgoal_tac "\<exists> M::var. var 0 = M")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> N::var. var 1 = N")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> P::var. var 2 = P")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "
    RED_app2
    = \<Pi>[c:BASE cEXP].
    \<Pi>[ca:BASE cEXP].
    \<Pi>[cb:BASE cEXP].(ATOM (APP (APP (CST cRED) (VAR (ca))) (VAR (cb)))  
    \<rightarrow> ATOM (APP (APP (CST cRED) (APP (APP (CST cAPP) (VAR (c))) (VAR (ca)))) (APP (APP (CST cAPP) (VAR (c)))
                                                             (VAR (cb)))))
")
  prefer 2 apply(simp add: fresh_prod fresh_atm RED_app2_def)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add:RED_app2_def)
  apply(rule_tac t="m" in asolve_FORALL,assumption)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm)
  apply(rule_tac t="n" in asolve_FORALL,assumption)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm subst_fresh_id)
  apply(rule_tac t="p" in asolve_FORALL,assumption)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm subst_fresh_id)

  apply(rule asolve_IMP)
  apply(simp)
  apply(rule asolve_ATOM)
  apply(rule wf_equiv_refl)  
  apply(auto intro:wf_equiv.intros sig_lam_elem[simplified] intro: simp add:prop_ty_def )
  done


lemma RED_lam:
  "\<lbrakk>sig_lam,(x,exp_ty)#\<Gamma>,thy_lam \<rightharpoonup> red_prop m m'; 
  sig_lam,(x,exp_ty)#\<Gamma> \<turnstile> m : exp_ty; 
  sig_lam,(x,exp_ty)#\<Gamma> \<turnstile> m' : exp_ty; 
  x \<sharp> \<Gamma>; valid_ctx \<Gamma>\<rbrakk>
  \<Longrightarrow> sig_lam,\<Gamma>,thy_lam \<rightharpoonup> 
      red_prop (APP (CST cLAM) (LAM x m))
               (APP (CST cLAM) (LAM x m'))"
  apply(simp add: red_prop_def)
  apply(rule_tac \<phi>="RED_lam" in solve_ATOM)
  apply(simp add:thy_lam_def)
  apply(subgoal_tac "\<exists> M::var. var 0 = M")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> N::var. var 1 = N")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> P::var. var 2 = P")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var)
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "
    RED_lam
    = 
    \<Pi>[c:(exp_ty ~> exp_ty)].( 
    \<Pi>[ca:(exp_ty ~> exp_ty)].( 
    (\<Pi>[cb:exp_ty]. (red_prop (APP (VAR (c)) (VAR (cb))) (APP (VAR (ca)) (VAR (cb))))) \<rightarrow> red_prop (lam_exp (VAR (c))) (lam_exp (VAR (ca)))))
    ")
  prefer 2 apply(simp add: fresh_prod fresh_atm RED_lam_def)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add:RED_lam_def)
  apply(rule_tac t="LAM x m" in asolve_FORALL)
  apply(rule wf_LAM,assumption+)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm)
  apply(rule_tac t="LAM x m'" in asolve_FORALL)
  apply(rule wf_LAM,assumption+)
  prefer 2 apply(simp add:fresh_prod abs_fresh subst_fresh2 thy_lam_fresh)
  apply(simp add:fresh_prod abs_fresh fresh_atm subst_fresh_id)
  apply(rule asolve_IMP)
  apply(rule solve_FORALL)
  apply(subgoal_tac "sig_lam,(cb, BASE cEXP) # \<Gamma>,thy_lam \<rightharpoonup> ATOM (APP (APP (CST cRED) (m{x::=VAR cb})) (m'{x::=VAR cb}))")
  prefer 2 apply(drule_tac pi="[(x,cb)]" in  solve.eqvt)
           apply(perm_simp add:subst_fresh thy_lam_fresh subst_eqvt subst_swap2)
  apply(clarify)
  apply(erule solve_closed_under_equiv_2)
  apply(rule wf_equiv_app )
  apply(rule wf_equiv_app)
  apply(rule wf_equiv_cst,simp) 
  apply( rule sig_lam_elem)
  apply(rule wf_equiv_sym)
  apply(rule wf_equiv_beta)
  apply(rule wf_APP)
  apply(rule wf_LAM)
  apply(simp add: fresh_list_cons fresh_prod fresh_atm)
  apply(erule weakening,auto)
  apply(simp add: fresh_list_cons fresh_prod fresh_atm)
  apply(simp add: fresh_list_cons fresh_prod fresh_atm)

  apply(rule wf_equiv_sym)
  apply(rule wf_equiv_beta)
  apply(rule wf_APP)
  apply(rule wf_LAM)
  apply(simp add: fresh_list_cons fresh_prod fresh_atm)
  apply(erule weakening,auto)
  apply(simp add: fresh_list_cons fresh_prod fresh_atm)
  apply(simp add: fresh_list_cons fresh_prod fresh_atm)
  apply(simp add:thy_lam_fresh fresh_prod)
    (* done showing universally quantified hyp! *)
  apply(rule asolve_ATOM)
  apply(rule wf_equiv_refl)
  apply(auto intro:sig_lam_elem)
  done



theorem enc_pres_RED:
  "\<lbrakk>red t u; X \<turnstile> t; X \<turnstile> u; valid X\<rbrakk> \<Longrightarrow> sig_lam, trans_ctx X, thy_lam \<rightharpoonup> red_prop (enc t) (enc u)"
  apply(nominal_induct avoiding: X rule:red.strong_inducts)
  (* case 1 *)
  apply(simp add:enc_preserves_subst)
  apply(erule Lambda.wf_inv, simp add:lam.inject)
  apply(erule_tac x="x" in Lambda.wf.strong_cases) back 
  apply(simp_all add:lam.inject abs_fresh alpha, clarify)+
  apply(subgoal_tac "(x,exp_ty) # (trans_ctx Xa) = trans_ctx (x#Xa)")
  prefer 2 apply(simp add:trans_ctx_simp)
  apply(rule RED_beta[simplified])
  apply(simp, erule enc_wf[simplified])+
  apply(simp add:trans_ctx_fresh fresh_prod enc_fresh)
    (* case 2 *)
  apply(clarify,simp add:lam.inject)+
  apply(rule RED_app1[simplified])
  apply(blast)
  apply(erule enc_wf[simplified])+
    (* case 3 *)
  apply(clarify,simp add:lam.inject)+
  apply(rule RED_app2[simplified])
  apply(blast)
  apply(erule enc_wf[simplified])+
    (* case 4 *)
  apply(erule_tac x="x" in Lambda.wf.strong_cases,simp_all add:lam.inject alpha abs_fresh)
  apply(erule_tac x="x" in Lambda.wf.strong_cases,simp_all add:lam.inject alpha abs_fresh)
  apply(clarify)
  apply(subgoal_tac "(x,BASE cEXP)#trans_ctx Xb = trans_ctx (x # Xb)")
  prefer 2 apply(simp add:trans_ctx_def)
  apply(subgoal_tac "valid (x#Xb)")
  prefer 2 apply(blast)
  apply(rule RED_lam[simplified])
  apply(simp_all)
  apply(erule enc_wf [simplified])+
  apply(simp add:trans_ctx_fresh)
  apply(blast intro:valid_trans_valid)
  done


  




(* Preservation direction *)

  

lemma wf_equiv_RED_inv:
  "\<lbrakk>sig_lam,\<Gamma> \<turnstile> APP (APP (CST cRED) M) N \<approx> APP (APP (CST cRED) M') N' : prop_ty; 
  valid_ctx \<Gamma>\<rbrakk> \<Longrightarrow> 
  sig_lam,\<Gamma> \<turnstile> M \<approx> M' : exp_ty \<and> sig_lam,\<Gamma> \<turnstile> N \<approx> N' : exp_ty"
  apply(frule wf_equiv_wf_,simp)
  apply(drule completeness,simp_all add:sig_lam_valid)
  apply(clarify)
  apply(drule to_can_whnf_to_atm,blast)+
  apply(erule to_atm.cases,simp_all add:hoas.inject,clarify)
  apply(erule to_atm.cases,simp_all add:hoas.inject,clarify)
  apply(erule to_atm.cases,simp_all add:hoas.inject,clarify)
  apply(erule to_atm.cases,simp_all add:hoas.inject,clarify)
  apply(erule to_atm.cases,simp_all add:hoas.inject,clarify)
  apply(erule to_atm.cases,simp_all add:hoas.inject,clarify)
  apply(erule wf_inv, simp_all add:hoas.inject,clarify)+
  apply(drule sig_lam_lookup,simp add:hoas_ty.inject,clarsimp)+
  apply(intro conjI)
  apply(rule wf_equiv_trans)
  apply(rule equivalence,  simp_all add:sig_lam_valid)
  apply(rule wf_equiv_sym,rule equivalence, simp_all add:sig_lam_valid)
  apply(rule wf_equiv_trans)
  apply(rule equivalence,  simp_all add:sig_lam_valid)
  apply(rule wf_equiv_sym,rule equivalence, simp_all add:sig_lam_valid)
  done


lemma RED_app1_inv:
  "\<lbrakk>sig_lam,\<Gamma>,thy_lam | RED_app1 \<rightharpoonup> APP (APP (CST cRED) M) N @ n;
  valid_ctx \<Gamma>\<rbrakk>
  \<Longrightarrow> 
  (\<exists> M' N' P. 
  sig_lam,\<Gamma> \<turnstile> M \<approx> app_exp M' N' : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> N \<approx> app_exp P N' : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> N' : exp_ty
  \<and> sig_lam,\<Gamma>,thy_lam \<rightharpoonup> red_prop M' P @ n)"
  apply(subgoal_tac "\<exists> M::var. var 0 = M")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> N::var. var 1 = N")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> P::var. var 2 = P")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "
    RED_app1
    = \<Pi>[c:BASE cEXP].
    \<Pi>[ca:BASE cEXP].
    \<Pi>[cb:BASE cEXP].(ATOM (APP (APP (CST cRED) (VAR (c))) (VAR (cb)))  
    \<rightarrow> ATOM (APP (APP (CST cRED) (APP (APP (CST cAPP) (VAR (c))) (VAR (ca)))) (APP (APP (CST cAPP) (VAR (cb)))
                                                             (VAR (ca)))))
")
  prefer 2 apply(simp add: fresh_prod fresh_atm RED_app1_def)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add:RED_app1_def)
  apply(simp add:fresh_prod fresh_atm, clarify)
  apply(erule_tac x="c" in  atomic_solve_n.strong_cases)
  apply(clarify)
  apply(simp_all add: alpha hoas_form.inject hoas.inject abs_fresh trans_ctx_fresh thy_lam_fresh )
  apply(clarify)
  apply(perm_simp add:fresh_atm)
  apply(subgoal_tac "ca \<sharp> t \<and> cb \<sharp> t")
  prefer 2 apply(auto intro:  wf_fresh trans_ctx_fresh)
  apply(simp add:fresh_atm)
  apply(erule_tac x="ca" in  atomic_solve_n.strong_cases)
  apply(clarify)
  apply(simp_all add: alpha hoas_form.inject hoas.inject abs_fresh trans_ctx_fresh thy_lam_fresh )
  apply(clarify)
  apply(perm_simp add:fresh_atm)
  apply(subgoal_tac "cb \<sharp> ta")
  prefer 2 apply(auto intro:  wf_fresh trans_ctx_fresh)
  apply(simp add:fresh_atm subst_fresh_id)
  apply(erule_tac x="cb" in  atomic_solve_n.strong_cases)
  apply(clarify)
  apply(simp_all add: alpha hoas_form.inject hoas.inject abs_fresh trans_ctx_fresh thy_lam_fresh )
  apply(clarify)
  apply(perm_simp add:fresh_atm)
  apply(simp add:fresh_atm subst_fresh_id)
  apply(erule solven_inv, simp_all add:hoas_form.inject,clarify)
  apply(erule solven_inv, simp_all add:hoas_form.inject,clarify)
  apply(drule wf_equiv_RED_inv[simplified])
  apply(auto intro: valid_trans_valid sig_lam_valid)
  apply(auto intro:wf_equiv_sym)
  done

lemma RED_app2_inv:
  "\<lbrakk>sig_lam,\<Gamma>,thy_lam | RED_app2 \<rightharpoonup> APP (APP (CST cRED) M) N @ n;
  valid_ctx \<Gamma>\<rbrakk>
  \<Longrightarrow> 
  (\<exists> M' N' P. 
  sig_lam,\<Gamma> \<turnstile> M \<approx> app_exp M' N' : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> N \<approx> app_exp M' P : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> M' : exp_ty
  \<and> sig_lam,\<Gamma>,thy_lam \<rightharpoonup> red_prop N' P @ n)"
  apply(subgoal_tac "\<exists> M::var. var 0 = M")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> N::var. var 1 = N")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> P::var. var 2 = P")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "
    RED_app2
    = \<Pi>[c:BASE cEXP].
    \<Pi>[ca:BASE cEXP].
    \<Pi>[cb:BASE cEXP].(ATOM (APP (APP (CST cRED) (VAR (ca))) (VAR (cb)))  
    \<rightarrow> ATOM (APP (APP (CST cRED) (APP (APP (CST cAPP) (VAR (c))) (VAR (ca)))) (APP (APP (CST cAPP) (VAR (c)))
                                                             (VAR (cb)))))
")
  prefer 2 apply(simp add: fresh_prod fresh_atm RED_app2_def)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add:RED_app2_def)
  apply(simp add:fresh_prod fresh_atm, clarify)
  apply(erule_tac x="c" in  atomic_solve_n.strong_cases)
  apply(clarify)
  apply(simp_all add: alpha hoas_form.inject hoas.inject abs_fresh trans_ctx_fresh thy_lam_fresh )
  apply(clarify)
  apply(perm_simp add:fresh_atm)
  apply(subgoal_tac "ca \<sharp> t \<and> cb \<sharp> t")
  prefer 2 apply(auto intro:  wf_fresh trans_ctx_fresh)
  apply(simp add:fresh_atm)
  apply(erule_tac x="ca" in  atomic_solve_n.strong_cases)
  apply(clarify)
  apply(simp_all add: alpha hoas_form.inject hoas.inject abs_fresh trans_ctx_fresh thy_lam_fresh )
  apply(clarify)
  apply(perm_simp add:fresh_atm)
  apply(subgoal_tac "cb \<sharp> ta")
  prefer 2 apply(auto intro:  wf_fresh trans_ctx_fresh)
  apply(simp add:fresh_atm subst_fresh_id)
  apply(erule_tac x="cb" in  atomic_solve_n.strong_cases)
  apply(clarify)
  apply(simp_all add: alpha hoas_form.inject hoas.inject abs_fresh trans_ctx_fresh thy_lam_fresh )
  apply(clarify)
  apply(perm_simp add:fresh_atm)
  apply(simp add:fresh_atm subst_fresh_id)
  apply(erule solven_inv, simp_all add:hoas_form.inject,clarify)
  apply(erule solven_inv, simp_all add:hoas_form.inject,clarify)
  apply(drule wf_equiv_RED_inv[simplified])
  apply(auto intro: valid_trans_valid sig_lam_valid)
  apply(auto intro:wf_equiv_sym)
  done

lemma RED_lam_inv:
  "\<lbrakk>sig_lam,\<Gamma>,thy_lam | RED_lam \<rightharpoonup> APP (APP (CST cRED) M) N @ n;
  valid_ctx \<Gamma>\<rbrakk>
  \<Longrightarrow> 
  (\<exists> x M' N'. 
  x \<sharp> (\<Gamma>,M',N') \<and> 
  sig_lam,\<Gamma> \<turnstile> M \<approx> lam_exp M' : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> N \<approx> lam_exp N' : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> M' : exp_ty ~> exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile>  N' : exp_ty ~> exp_ty
  \<and> sig_lam,(x,BASE cEXP)#\<Gamma>,thy_lam \<rightharpoonup> red_prop (APP M' (VAR x)) (APP N' (VAR x)) @ n)"
 apply(subgoal_tac "\<exists> M::var. var 0 = M")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> N::var. var 1 = N")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> P::var. var 2 = P")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var)
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "
    RED_lam
    = 
    \<Pi>[c:(exp_ty ~> exp_ty)].( 
    \<Pi>[ca:(exp_ty ~> exp_ty)].( 
    (\<Pi>[cb:exp_ty]. (red_prop (APP (VAR (c)) (VAR (cb))) (APP (VAR (ca)) (VAR (cb))))) \<rightarrow> red_prop (lam_exp (VAR (c))) (lam_exp (VAR (ca)))))
    ")
  prefer 2 apply(simp add: fresh_prod fresh_atm RED_lam_def)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add:RED_lam_def)
  apply(simp add:fresh_prod fresh_atm, clarify)
  apply(simp_all add: alpha hoas_form.inject hoas_ty.inject hoas.inject abs_fresh )
  apply(perm_simp add:fresh_atm)
  apply(erule_tac x="c" in  atomic_solve_n.strong_cases,simp_all add:hoas_form.inject  abs_fresh alpha trans_ctx_fresh thy_lam_fresh)
  apply(clarify)
  apply(subgoal_tac "ca \<sharp> t \<and> cb \<sharp> t")
  prefer 2 apply(auto intro:  wf_fresh trans_ctx_fresh)
  apply(simp add:fresh_atm)
  apply(erule_tac x="ca" in  atomic_solve_n.strong_cases,simp_all add:hoas_form.inject  abs_fresh alpha trans_ctx_fresh thy_lam_fresh)
  apply(clarify)
  apply(subgoal_tac "cb \<sharp> ta")
  prefer 2 apply(auto intro:  wf_fresh trans_ctx_fresh)
  apply(simp add:fresh_atm subst_fresh_id)
  
  apply(erule solven_inv,simp_all add:hoas_form.inject,clarify)+
  apply(erule_tac x="cb" in solve_n.strong_cases,simp_all add:hoas_form.inject  abs_fresh alpha trans_ctx_fresh thy_lam_fresh)
  apply(clarify)

  apply(drule wf_equiv_RED_inv[simplified])
  apply(simp_all add: valid_trans_valid sig_lam_valid fresh_prod)
  apply(auto intro:wf_equiv_sym)
  done


 
lemma RED_beta_inv:
  "\<lbrakk>sig_lam,\<Gamma>,thy_lam | RED_beta \<rightharpoonup> APP (APP (CST cRED) M) N @ n;
  valid_ctx \<Gamma> \<rbrakk>
  \<Longrightarrow> 
  (\<exists> x M' N'. 
  x \<sharp> (\<Gamma>,N') \<and>
  sig_lam,\<Gamma> \<turnstile> M \<approx> app_exp (lam_exp (LAM x M')) N' : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> N \<approx> APP (LAM x M') N' : exp_ty
  \<and> sig_lam,(x,exp_ty)#\<Gamma> \<turnstile> M' : exp_ty
  \<and> sig_lam,\<Gamma> \<turnstile> N' : exp_ty)"
  apply(subgoal_tac "\<exists> y::var. var 0 = y")
  prefer 2 apply(simp)
  apply(subgoal_tac "\<exists> z::var. var 1 = z")
  prefer 2 apply(simp)
  apply(erule exE)+
  apply(generate_fresh var )
  apply(generate_fresh var )
  apply(clarsimp)
  apply(subgoal_tac "RED_beta = \<Pi>[c:(BASE cEXP ~> BASE cEXP)].\<Pi>[ca:BASE cEXP].ATOM (APP (APP (CST cRED) (APP (APP (CST cAPP) (APP (CST cLAM) (VAR (c)))) (VAR (ca))))
                            (APP (VAR (c))
                              (VAR (ca))))")
  prefer 2 apply(simp add:RED_beta_def)
           apply(simp add: fresh_prod fresh_atm)
           apply(clarify)
	   apply(perm_simp add: hoas_form.inject alpha eqvts fresh_atm abs_fresh)
  apply(simp add: RED_beta_def)
  apply(simp add:fresh_prod fresh_atm, clarify)
  apply(simp_all add: alpha hoas_form.inject hoas_ty.inject hoas.inject abs_fresh )
  apply(perm_simp add:fresh_atm)
   apply(erule_tac x="c" in  atomic_solve_n.strong_cases,simp_all add:hoas_form.inject  abs_fresh alpha trans_ctx_fresh thy_lam_fresh)
  apply(clarify)
  apply(subgoal_tac "ca \<sharp> t")
  prefer 2 apply(auto intro:  wf_fresh trans_ctx_fresh)
  apply(simp add:fresh_atm)
  apply(erule_tac x="ca" in  atomic_solve_n.strong_cases,simp_all add:hoas_form.inject  abs_fresh alpha trans_ctx_fresh thy_lam_fresh)
  apply(clarify)
  apply(simp add:fresh_atm subst_fresh_id)
 
  apply(erule solven_inv,simp_all add:hoas_form.inject,clarify)+

  apply(drule wf_equiv_RED_inv[simplified],auto intro:valid_trans_valid sig_lam_valid)

  apply(generate_fresh var)
  apply(rule_tac x="cb" in exI, simp add:fresh_prod,clarify)
  apply(rule_tac x="APP t (VAR cb)" in exI)
  apply(rule_tac x="ta" in exI)
  apply(simp)
  apply(rule conjI)
  apply(rule wf_equiv_trans,erule wf_equiv_sym)
  apply(intro wf_equiv_app wf_equiv_cst, rule sig_lam_elem[simplified], rule sig_lam_elem[simplified], erule wf_equiv_eta)
  apply(simp add:fresh_prod trans_ctx_fresh)
  apply(blast intro:wf_equiv_refl)

  apply(auto simp add:trans_ctx_simp)

  apply(rule wf_equiv_trans, erule wf_equiv_sym)
  apply(rule wf_equiv_sym)
  apply(rule wf_equiv_trans, rule wf_equiv_beta)
  apply(intro wf.intros)
  apply(simp_all add:trans_ctx_fresh)
  apply(erule weakening,auto simp add:trans_ctx_fresh valid_trans_valid)
  apply(simp add:subst_fresh_id, erule wf_equiv_refl)
  apply(erule wf_equiv_refl)
  apply(erule weakening,auto simp add:trans_ctx_fresh valid_trans_valid)
  done


inductive to_enc :: "var list \<Rightarrow> lam \<Rightarrow> hoas \<Rightarrow> bool" ("_ \<turnstile> _ \<rightleftharpoons> _" [60,60,60] 60)
where
  to_enc_intro: "\<lbrakk>valid X; sig_lam, trans_ctx X \<turnstile> M \<approx> (enc t) : exp_ty\<rbrakk> \<Longrightarrow> X \<turnstile> t \<rightleftharpoons> M"

inductive_cases to_enc_elim:
  "X \<turnstile> t \<rightleftharpoons> M"


lemma to_enc_var:
  "\<lbrakk>x \<in> set X; valid X\<rbrakk> \<Longrightarrow> X \<turnstile> Var x \<rightleftharpoons> VAR x"
  apply(rule to_enc_intro,auto simp add:trans_ctx_def)
  done
  
lemma to_enc_app:
  "\<lbrakk>X \<turnstile> t \<rightleftharpoons> M; X \<turnstile> u \<rightleftharpoons> N\<rbrakk>
       \<Longrightarrow> X \<turnstile> App t u \<rightleftharpoons> APP (APP (CST cAPP) M) N"
  apply(erule to_enc_elim)+
  apply(rule to_enc_intro)
  apply(auto intro!: sig_lam_elem)
  done

lemma to_enc_lam:
  "\<lbrakk>x#X \<turnstile> t \<rightleftharpoons> M; x \<sharp> X\<rbrakk>
       \<Longrightarrow> X \<turnstile> Lam x t \<rightleftharpoons> APP (CST cLAM) (LAM x M)"
  apply(erule to_enc_elim)+
  apply(erule Lambda.valid.cases,simp_all add:trans_ctx_simp,clarify)
  apply(erule to_enc_intro)
  apply(auto intro!:sig_lam_elem simp add: trans_ctx_fresh valid_trans_valid)
  done


lemma wf_equiv_to_enc:
  "\<lbrakk>sig_lam,trans_ctx X \<turnstile> M \<approx> N : BASE cEXP; X \<turnstile> t \<rightleftharpoons> M\<rbrakk> \<Longrightarrow> X \<turnstile> t \<rightleftharpoons> N"
  apply(erule to_enc_elim)
  apply(erule to_enc_intro)
  apply(auto intro: wf_equiv_sym wf_equiv_trans)
  done

lemma wf_equiv_to_enc2:
  "\<lbrakk>sig_lam,trans_ctx X \<turnstile> M \<approx> N : BASE cEXP\<rbrakk> \<Longrightarrow> X \<turnstile> t \<rightleftharpoons> M = X \<turnstile> t \<rightleftharpoons> N"
  apply(auto intro: wf_equiv_to_enc wf_equiv_sym)
  done

lemma to_enc_subst:
  "\<lbrakk>x # X \<turnstile> t \<rightleftharpoons> M'; X \<turnstile> ta \<rightleftharpoons> N'; x \<sharp> X\<rbrakk>
       \<Longrightarrow> X \<turnstile> t[x::=ta] \<rightleftharpoons> M'{x::=N'}"
  apply(erule to_enc_elim)+
  apply(erule to_enc_intro)
  apply(simp add:enc_preserves_subst)
  apply(rule wf_equiv_equiv_subst1)
  apply(simp_all add:valid_trans_valid trans_ctx_simp trans_ctx_fresh)
  apply(erule valid.cases, simp_all, erule valid_trans_valid)
  done


lemma to_enc_fresh:
  fixes x::var
  shows "\<lbrakk>X \<turnstile> t \<rightleftharpoons> M; x \<sharp> X\<rbrakk> \<Longrightarrow> x \<sharp> t \<and> x \<sharp> M" 
  apply(auto elim!: to_enc_elim intro:HOAS.wf_fresh Lambda.wf_fresh)
  apply(drule wf_equiv_wf(2))
  apply(erule valid_trans_valid)
  apply(drule wf_enc_valid)
  apply(erule Lambda.wf_fresh,simp)
  apply(drule wf_equiv_wf(1))
  apply(erule valid_trans_valid)
  apply(erule wf_fresh)
  apply(simp add: trans_ctx_fresh)
  done



lemma wf_to_enc: 
  "\<lbrakk>sig_lam,trans_ctx X \<turnstile> M : BASE cEXP; valid X\<rbrakk> \<Longrightarrow> \<exists> t. X \<turnstile> t \<rightleftharpoons> M"
  apply(drule wf_implies_enc_exists,auto)
  apply(rule_tac x=t in exI)
  apply(rule to_enc_intro,auto)
  done

theorem to_enc_reflects_RED_height:
  "\<lbrakk>sig_lam, trans_ctx X, thy_lam \<rightharpoonup> red_prop M N @ n; valid X\<rbrakk> \<Longrightarrow> 
  \<exists> t u. X \<turnstile> t \<rightleftharpoons> M \<and> X \<turnstile> u \<rightleftharpoons> N \<and> red t u"
  apply(induct n arbitrary: M N X) 
  apply(simp add:red_prop_def)
  apply(erule solve_n.cases, simp_all add:hoas.inject)
  apply(erule solve_n.cases,simp_all add:hoas.inject hoas_form.inject, clarify)
  apply(auto dest!: thy_lam_disj elim: disjE)
    (* case 1: we used HOAS app1 rule *)
  apply(drule RED_app1_inv,erule valid_trans_valid,clarify)
  apply(drule_tac x="M'" in meta_spec)
  apply(drule_tac x="P" in meta_spec)
  apply(drule_tac x="X" in meta_spec)
  apply(simp, drule_tac M="N'" in wf_to_enc,assumption)
  apply(clarsimp)
  apply(rule_tac x="App t ta" in exI)
  apply(safe)
  apply(rule wf_equiv_to_enc,erule wf_equiv_sym)
  apply(blast intro: to_enc_app)
  apply(rule_tac x="App u ta" in exI)
  apply(safe)
  apply(rule wf_equiv_to_enc, erule wf_equiv_sym)
  apply(blast intro: to_enc_app)
  apply(blast intro:red.intros)
    (* case 2: we used HOAS app2 rule *)
  apply(drule RED_app2_inv,erule valid_trans_valid,clarify)
  apply(drule_tac x="N'" in meta_spec)
  apply(drule_tac x="P" in meta_spec)
  apply(drule_tac x="X" in meta_spec)
  apply(simp, drule_tac M="M'" in wf_to_enc,assumption)
  apply(clarsimp)
  apply(rule_tac x="App ta t" in exI)
  apply(safe)
  apply(rule wf_equiv_to_enc,erule wf_equiv_sym)
  apply(blast intro: to_enc_app)
  apply(rule_tac x="App ta u" in exI)
  apply(safe)
  apply(rule wf_equiv_to_enc,erule wf_equiv_sym)
  apply(blast intro: to_enc_app)
  apply(blast intro:red.intros)
    (* case 3: we used HOAS lam rule *)
  apply(drule RED_lam_inv,erule valid_trans_valid, simp add: fresh_prod,clarify)
  apply(drule_tac x="(APP M' (VAR x))" in meta_spec)
  apply(drule_tac x="(APP N' (VAR x))" in meta_spec)
  apply(drule_tac x="x#X" in meta_spec)
  apply(subgoal_tac "x \<sharp> X")
  prefer 2 apply( blast intro: trans_ctx_fresh_inv) 
  apply(subgoal_tac "valid (x # X)")
  prefer 2 apply( blast )
  apply(simp add:trans_ctx_simp)
  apply(clarify)
  apply(rule_tac x="Lam x t" in exI)
  apply(safe)
  apply(subgoal_tac "sig_lam,trans_ctx X \<turnstile> APP (CST cLAM) (LAM x (APP M' (VAR x))) \<approx> M : BASE cEXP")
  prefer 2 apply(rule wf_equiv_sym, erule wf_equiv_trans)
           apply(auto intro:wf_equiv.intros sig_lam_elem simp add:fresh_prod trans_ctx_fresh)
  apply(erule wf_equiv_to_enc)
  apply(blast intro: to_enc_lam)
  apply(rule_tac x="Lam x u" in exI)
  apply(safe)
  apply(subgoal_tac "sig_lam,trans_ctx X \<turnstile> APP (CST cLAM) (LAM x (APP N' (VAR x))) \<approx> N : BASE cEXP")
  prefer 2 apply(rule wf_equiv_sym, erule wf_equiv_trans)
           apply(auto intro:wf_equiv.intros sig_lam_elem simp add:fresh_prod trans_ctx_fresh)
  apply(erule wf_equiv_to_enc)
  apply(blast intro: to_enc_lam)
(* case 4 : used HOAS beta rule *)
  apply(drule RED_beta_inv,erule valid_trans_valid,clarify+)
  apply(simp)
  apply(subgoal_tac "x \<sharp> X")
  prefer 2 apply(simp add: trans_ctx_fresh_inv fresh_prod)
  apply(subgoal_tac "(\<exists> t. x # X \<turnstile> t \<rightleftharpoons> M')")
  prefer 2 apply(rule wf_to_enc, simp add:trans_ctx_simp,blast)
  apply(subgoal_tac "(\<exists> ta. X \<turnstile> ta \<rightleftharpoons> N')")
  prefer 2 apply(blast intro: wf_to_enc)
  apply(clarify)
  apply(rule_tac x="App (Lam x t) ta" in exI)
  apply(safe)
  apply(simp add: wf_equiv_to_enc2)
  apply(blast intro: to_enc_app to_enc_lam)
  apply(rule_tac x="t[x::=ta]" in exI)
  apply(safe)
  apply(subgoal_tac "sig_lam,trans_ctx X \<turnstile> M'{x::=N'} \<approx> N : BASE cEXP")
  prefer 2 apply(rule wf_equiv_sym, erule wf_equiv_trans, rule wf_equiv_beta)
           apply(auto intro: wf_APP wf_LAM simp add: trans_ctx_fresh fresh_prod)
  apply(erule wf_equiv_to_enc)
  apply(erule to_enc_subst,simp_all)
  apply(rule Lambda.red.intros)
  apply(simp add: to_enc_fresh fresh_prod)
  done


theorem to_enc_reflects_RED:
  "\<lbrakk>sig_lam, trans_ctx X, thy_lam \<rightharpoonup> red_prop M N; valid X\<rbrakk> \<Longrightarrow> 
  \<exists> t u. X \<turnstile> t \<rightleftharpoons> M \<and> X \<turnstile> u \<rightleftharpoons> N \<and> red t u"
  apply(simp add:solve_equals_solve_n,clarify)
  apply(auto dest: to_enc_reflects_RED_height[simplified])
  done




lemma to_enc_injective:
  "\<lbrakk>X \<turnstile> t \<rightleftharpoons> M ; X \<turnstile> u \<rightleftharpoons> M\<rbrakk> \<Longrightarrow> t = u"
  apply(erule to_enc_elim)+
  apply(rule wf_equiv_enc_equal,auto)
  apply(auto intro:wf_equiv_sym wf_equiv_trans )
  done
  

(* Here we summarize the properties constituting the interpretation *)

theorem enc_refl_RED:
  "\<lbrakk>sig_lam, trans_ctx X, thy_lam \<rightharpoonup> red_prop (enc t) (enc u); valid X;X \<turnstile> t ; X \<turnstile> u\<rbrakk> \<Longrightarrow> red t u"
  apply(drule to_enc_reflects_RED)
  apply(simp)
  apply(clarsimp)
  apply(erule to_enc_elim)+
  apply(drule wf_equiv_enc_equal,auto)+
  done

theorem EQ_refl:
  "M \<in> EXP \<Longrightarrow> (M,M) \<in> EQ"
  apply(simp add:EQ_def EQ_in_def EXP_def EXP_in_def)
  apply(erule wf_equiv_refl)
  done

theorem EQ_symm:
  "\<lbrakk>M \<in> EXP; N \<in> EXP\<rbrakk> \<Longrightarrow> (M,N) \<in> EQ \<Longrightarrow> (N,M) \<in> EQ"
   apply(simp add:EQ_def EQ_in_def EXP_def EXP_in_def)
  apply(erule wf_equiv_sym)
  done
 
theorem EQ_trans:
  "\<lbrakk>M \<in> EXP; N \<in> EXP; P \<in> EXP\<rbrakk> \<Longrightarrow> (M,N) \<in> EQ \<Longrightarrow> (N,P) \<in> EQ \<Longrightarrow> (M,P) \<in> EQ"
   apply(simp add:EQ_def EQ_in_def EXP_def EXP_in_def)
  apply(erule wf_equiv_trans,simp)
  done
  

theorem enc_injective: 
  "\<lbrakk>[] \<turnstile> t; [] \<turnstile> u\<rbrakk> \<Longrightarrow> (enc t, enc u) \<in> EQ \<Longrightarrow> t = u"
  apply(rule wf_equiv_enc_equal)
  apply(simp add:EQ_def EQ_in_def,auto)
  done

theorem enc_surjective: 
  "M \<in> EXP \<Longrightarrow> \<exists> t. (enc t,M) \<in> EQ"
  apply(simp add:EXP_in_def EXP_def EQ_in_def EQ_def)
  apply(drule wf_implies_enc_exists)
  apply(auto intro:wf_equiv_sym)
  done
  
theorem enc_range_EXP: 
  "[] \<turnstile> t \<Longrightarrow> enc t \<in> EXP"
  sorry

theorem eq_equals_EQ:
  "\<lbrakk>[] \<turnstile> t ; [] \<turnstile> u \<rbrakk> \<Longrightarrow>  t = u = ((enc t,enc u) \<in> EQ)"
  apply(auto)
  apply(rule EQ_refl)
  apply(erule enc_range_EXP)
  apply(rule enc_injective)
  apply(auto)
  done

theorem red_equals_RED:
  "\<lbrakk>[] \<turnstile> t ; [] \<turnstile> u \<rbrakk> \<Longrightarrow> red t u = ((enc t,enc u) \<in> RED)"
  apply(simp add:RED_def RED_in_def)
  apply(auto dest: enc_pres_RED enc_refl_RED[simplified])
  done

 
 


 
end